// install trigger -> cache index.html
self.addEventListener('install', event => {
	const indexPage = new Request('./');
	event.waitUntil(
		fetch(indexPage).then(response => {
			return caches.open('offline').then(cache => {
				return cache.put(indexPage, response);
			});
		})
	);
});
// fetch trigger -> fetch from server, save to cache, if fail: serve from cache
self.addEventListener('fetch', event => {
	event.respondWith(
		fetch(event.request).then(response => {
			return caches.open('offline').then(cache => {
				if (event.request.method == 'GET') {
					cache.put(event.request, response.clone());
				}
				return response;
			});
		}).catch(error => {
			return caches.open('offline').then(cache => {
				return cache.match(event.request);
			});
		})
	);
});
